// Let's run some initializations at the startup.
initialize();

//
// Call components to initialize themselves.
//
function initialize()
{
    userManager.initialize();
    deliciousService.login(dummyCallback);  // Initialize userManager first to set default user.
}

//
// Dummy callback to enable asynchronous login at startup.
//
function dummyCallback(resp)
{
}

//
// Gets the target URL either from RSS reader headers or from the active document.
//
function getUrl()
{
    var url = "";
    var expandedContentBaseBox = document.getElementById("expandedcontent-baseBox");
    if (expandedContentBaseBox) {
        url = document.getAnonymousElementByAttribute(expandedContentBaseBox,"anonid","headerValue").value;
    }
    if (!url) {
        url = window._content.document.location.href;
    }
    return url;
}

//
// Post current page
//
function postCurrentPage()
{
    var url = encodeURIComponent(getUrl());
    var title = encodeURIComponent(window._content.document.title);

    var focusedWindow = document.commandDispatcher.focusedWindow;
    var extended = encodeURIComponent(focusedWindow.getSelection());

    window.openDialog("chrome://delicious/content/add.xul", "", "chrome, resizable", "url="+url, "description="+title, "extended="+extended);
}

//
// Post clicked link
//
function postClickedLink()
{
    var clickedUrl;
    var clickedText;
    var extended = encodeURIComponent(window._content.getSelection());

    try
    {
        clickedUrl = gContextMenu.linkURL();
        clickedText = gContextMenu.linkText();
        //deliciousService.post(clickedUrl, clickedText, extended);
        window.openDialog("chrome://delicious/content/add.xul", "", "chrome, resizable", "url="+escape(clickedUrl), "description="+escape(clickedText), "extended="+extended);
    }
    catch(e)
    {
        // TODO show error that should be shown
        alert("You have to right-click on a link...");
    }
}

//
// Finds the current page in del.icio.us
//
function findCurrentPage()
{
    var url = getUrl();

    deliciousService.findURL(url);
}

//
// Finds the clicked link in del.icio.us
//
function findClickedLink()
{
    var clickedUrl;

    try
    {
        clickedUrl = gContextMenu.linkURL();
        deliciousService.findURL(clickedUrl);
    }
    catch(e)
    {
        // TODO show error that should be shown
        alert("You have to right-click on a link...");
    }
}

